MODULE Zwei_Drei_Baum EXPORTS Main;

IMPORT SIO;

TYPE knoten = RECORD 
	        Succ: ARRAY [1..3] OF pknoten;
		Wert: ARRAY [0..2] OF CARDINAL;
                Vater: pknoten;
	      END;
TYPE pknoten = REF knoten;

VAR Der_Baum: pknoten;

PROCEDURE NeuesBlatt ( VAR pointer: pknoten; value: CARDINAL ) =
BEGIN
  pointer := NEW (pknoten);
  pointer^.Wert[0] := 0;
  pointer^.Wert[1] := 0;
  pointer^.Wert[2] := value;
  pointer^.Succ[1] := NIL;
  pointer^.Succ[2] := NIL;
  pointer^.Succ[3] := NIL;
  pointer^.Vater := NIL;
END NeuesBlatt;

PROCEDURE NeuerKnoten ( VAR Knoten:pknoten; w0,w1,w2:CARDINAL; s1,s2,s3:pknoten) =
BEGIN
  Knoten := NEW (pknoten);
  Knoten^.Wert[0] := w0;
  Knoten^.Wert[1] := w1;
  Knoten^.Wert[2] := w2;
  Knoten^.Succ[1] := s1;
  Knoten^.Succ[2] := s2;
  Knoten^.Succ[3] := s3;
  IF s1 # NIL THEN
    s1^.Vater := Knoten;
  END;
  IF s2 # NIL THEN
    s2^.Vater := Knoten;
  END;
  IF s3 # NIL THEN 
    s3^.Vater := Knoten;
  END;
END NeuerKnoten;

PROCEDURE Wert ( knoten: pknoten ) : CARDINAL =
(* liefert das kleinste Element des Baums *)
BEGIN
  IF knoten^.Wert[1] = 0 THEN
    RETURN knoten^.Wert[2];
  ELSE
    RETURN knoten^.Wert[0];
  END;
END Wert;

PROCEDURE Tausche ( b1,b2: pknoten; pos1,pos2: CARDINAL ) =
(* tauscht in zwei Knoten die Soehne an entsprechenden Positionen aus;
   die Vaeter werden dabei auch entsprechend modifiziert *) 
VAR helpInt:     CARDINAL;
    helpPointer: pknoten; 
BEGIN
  IF b1^.Succ[pos1] # NIL THEN
    b1^.Succ[pos1]^.Vater := b2;
  END;
  IF b2^.Succ[pos2] # NIL THEN
    b2^.Succ[pos2]^.Vater := b1;
  END;
  helpInt := b1^.Wert[pos1-1];
  b1^.Wert[pos1-1] := b2^.Wert[pos2-1];
  b2^.Wert[pos2-1] := helpInt;
  helpPointer := b1^.Succ[pos1];
  b1^.Succ[pos1] := b2^.Succ[pos2];
  b2^.Succ[pos2] := helpPointer;
END Tausche;

PROCEDURE FuegeEin ( aufnehmer, aufgenommener:pknoten ) =
(* fuegt in einen Knoten mit 2 Soehnen einen Teilbaum ein *)
BEGIN
  aufgenommener^.Vater := aufnehmer;        (* erst an Pos. 3 einfuegen *)
  aufnehmer^.Succ[3] := aufgenommener;
  aufnehmer^.Wert[2] := Wert (aufgenommener);
  IF aufnehmer^.Wert[2] < aufnehmer^.Wert[1] THEN  (* und dann an richtige *)
    Tausche (aufnehmer, aufnehmer, 2, 3);          (* Position tauschen *)
    IF aufnehmer^.Wert[1] < aufnehmer^.Wert[0] THEN
      Tausche (aufnehmer, aufnehmer, 1, 2);
    END;
  END;
END FuegeEin;
 
PROCEDURE Mische ( linker, rechter: pknoten ) =
(* verlangt, das der linke Knoten drei Soehne enthaelt und das im rechten 
   Knoten nur der 2. Sohn belegt ist; dieser wird entsprechend eingemischt;
   Funktion (a,b,c) + (NIL,d,NIL) -> (a',b',NIL) + (c',d',NIL) *)
BEGIN
  Tausche ( linker, rechter, 3, 1);
  IF ( rechter^.Wert[0] > rechter^.Wert[1] ) THEN
    Tausche ( rechter, rechter, 1, 2 );
    IF ( linker^.Wert[1] > rechter^.Wert[0] ) THEN
      Tausche ( linker, rechter, 2, 1 );
      IF ( linker^.Wert[0] > linker^.Wert[1] ) THEN
        Tausche ( linker, linker, 1, 2 );
      END;
    END;
  END;
END Mische;

PROCEDURE Insert ( VAR Baum: pknoten; Value: CARDINAL ) =
VAR v,z,z_,help:pknoten;
BEGIN
  Show ( Baum );
  SIO.PutLine("");
  IF Baum = NIL THEN
     NeuesBlatt ( Baum, Value ); (* Sonderfall: Einfuegen in leeren Baum *)
     RETURN;
  END;
  v := SearchMain ( Baum, Value );
  IF v^.Wert[2] = Value THEN    (* Falls Wert schon vorhanden nichts zu tun *)
     RETURN;
  END;
  NeuesBlatt ( z, Value );     (* neues Blatt anlegen *)
  WHILE z^.Vater = NIL DO   
    IF v = Baum THEN          (* gefundener Knoten ist Wurzel *)
      NeuerKnoten ( Baum, Wert(v), Wert(z), 0, v, z, NIL );
      IF Wert(v) > Wert(z) THEN         (* falls Fehlstellung *)
        Tausche ( Baum, Baum, 1, 2);    (* dann vertauschen *)
      END;
    ELSE
      v := v^.Vater;
      IF v^.Wert[2] = 0 THEN    (* v hat nur zwei Soehne *)
        FuegeEin ( v,z );
      ELSE
        NeuerKnoten ( z_, 0, Wert(z) ,0 , NIL, z, NIL ); 
        help := z;                (* neuer Knoten z_ mit Wert von z *)
        z := z_;                  (* z ist jetzt Vater von z_ *)
        z_ := help; 
        Mische ( v,z );           (* und schliesslich v und z gemaess Alg. *)
      END;                        (* zu zwei 2-er Knoten kombinieren *)
    END;  
  END;  
  (* und jetzt noch Werte nach oben propagieren *)
  WHILE v^.Vater # NIL DO
    v := v^.Vater;
    v^.Wert[0] := Wert ( v^.Succ[1] );
    v^.Wert[1] := Wert ( v^.Succ[2] );
    IF v^.Succ[3] # NIL THEN
      v^.Wert[2] := Wert ( v^.Succ[3] );
    END;
  END; 
END Insert;

PROCEDURE Search ( Baum: pknoten; Value: CARDINAL ) =
VAR v:pknoten;
BEGIN
  SIO.PutInt( Value );
  IF Baum = NIL THEN
    SIO.PutLine(" nicht in Menge");
  ELSE
    v := SearchMain ( Baum, Value );
    IF v^.Wert[2] = Value THEN
      SIO.PutLine(" in Menge enthalten");
    ELSE
      SIO.PutLine(" nicht in Menge enthalten");
    END;
  END; 
END Search;

PROCEDURE SearchMain ( Baum: pknoten; Value: CARDINAL ) : pknoten =
BEGIN
  WHILE Baum^.Wert[1] # 0 DO 
    IF Value < Baum^.Wert[1] THEN
      Baum := Baum^.Succ[1];
    ELSE 
      IF (Baum^.Wert[2] = 0 OR Value < Baum^.Wert[2]) THEN
        Baum := Baum^.Succ[2];
      ELSE
        Baum := Baum^.Succ[3];
      END;
    END;
  END;
  RETURN Baum;
END SearchMain;

PROCEDURE LiefereLeerenBaum () : pknoten =
BEGIN
  RETURN NIL;
END LiefereLeerenBaum;

PROCEDURE Show ( Baum: pknoten ) =
BEGIN
  IF (Baum # NIL ) THEN
     IF (Baum^.Wert[1]) = 0 THEN 
	SIO.PutInt ( Baum^.Wert[2] );
     ELSE
	SIO.PutText ( " [(" );
        SIO.PutInt(Baum^.Wert[0]); SIO.PutChar(',');
        SIO.PutInt(Baum^.Wert[1]); SIO.PutChar(',');
        SIO.PutInt(Baum^.Wert[2]); SIO.PutText(") ");
	Show ( Baum^.Succ[1] ); SIO.PutChar(' ');
	Show ( Baum^.Succ[2] );
	IF ( Baum^.Wert[2] # 0 ) THEN
	   SIO.PutChar(' '); Show ( Baum^.Succ[3] );
	END;
	SIO.PutText ( "] " );	
     END;
  END;
END Show;

BEGIN
  Der_Baum := LiefereLeerenBaum();
  Insert ( Der_Baum, 5);
  Insert ( Der_Baum, 8);
  Insert ( Der_Baum, 2);
  Insert ( Der_Baum, 12);
  Insert ( Der_Baum, 19);
  Insert ( Der_Baum, 16);
  Insert ( Der_Baum, 7);
  Show (Der_Baum);
  SIO.PutLine("");  
  Search ( Der_Baum, 2);
  Search ( Der_Baum, 6);
END Zwei_Drei_Baum.

